﻿/*----------------------------------------------------------------
variable declarations
----------------------------------------------------------------*/
// Declare array to store menu button items
var menuButtonItems:Array;
var resolutionMenuButtonItems:Array;
var bandMenuButtonItems:Array;
var vidAveragingXmlButtonItems:XML;
var resolutionXmlButtonItems:XML;
var bandXmlButtonItems:XML;

/*----------------------------------------------------------------
instantiate variables
----------------------------------------------------------------*/
menuButtonItems = new Array();
resolutionMenuButtonItems = new Array();
bandMenuButtonItems = new Array();
vidAveragingXmlButtonItems = new XML();
resolutionXmlButtonItems = new XML();
bandXmlButtonItems = new XML();
vidAveragingXmlButtonItems.ignoreWhite = true;
resolutionXmlButtonItems.ignoreWhite = true;
bandXmlButtonItems.ignoreWhite = true;

/*----------------------------------------------------------------
functions
----------------------------------------------------------------*/
SetAveraging = function(aMaxSegment:Number, aLabel:String):Void
{
	Averaging_txt.text = aLabel;
	maxDataSegments = aMaxSegment;
	dataSegmentsLoaded = 0;
	dataSegment = DATA_SEGMENT1;
	InitializeMagArray();
}

SetResolution = function(aMaxSamples:Number, aLabel:String):Void
{
   if ( SpectrumFlashDebug != NO_FLASH_DEBUG && aMaxSamples > 512)
      samples = 512;
	else
		samples = aMaxSamples;
  	Resolution_txt.text = aLabel;
	trace(samples);
	power =  Math.log(samples) / Math.log(2.0);
	dataSegmentsLoaded = 0;
	dataSegment = DATA_SEGMENT1;
  	InitializeMagArray();
  	if (( SpectrumFlashDebug == JS_LOADVARS_FLASH_DEBUG || SpectrumFlashDebug == NO_FLASH_DEBUG)
         && InitializationComplete)
      ExternalInterface.call("parent.client_SetRxSpectrumResolution", aMaxSamples );
}

SetBand = function(aBand:Boolean, aLabel:String):Void
{
  	Band_txt.text = aLabel;
  	if (( SpectrumFlashDebug == JS_LOADVARS_FLASH_DEBUG || SpectrumFlashDebug == NO_FLASH_DEBUG)
         && InitializationComplete)
      ExternalInterface.call("parent.client_SetRxSpectrumBand", aBand );
}

LoadXmlButtonItems = function(xmlItems:XML):Array 
{
	var buttonItemLength:Number = xmlItems.firstChild.childNodes.length;
   var buttonItems:Array = new Array();

	for (var i:Number = 0; i < buttonItemLength; i++) 
	{
		var oTempItems:Object = new Object();
		oTempItems["label"] = xmlItems.firstChild.childNodes[i].attributes.label;
		oTempItems["value"] = xmlItems.firstChild.childNodes[i].attributes.value;
		oTempItems["name"] = xmlItems.firstChild.childNodes[i].attributes.name;
		buttonItems[i] = oTempItems;
		delete oTempItems;
	};
	return(buttonItems);
};

// Updates the graph with new data
UpdateSwfSpectrumBand = function(aBand:Boolean):Void
{
   if ( aBand)
      Band_txt.text = "Wide";
   else	  
      Band_txt.text = "Narrow";
}
ExternalInterface.addCallback("UpdateSwfSpectrumBand", this, UpdateSwfSpectrumBand);


/*----------------------------------------------------------------
event handlers
----------------------------------------------------------------*/
vidAveragingXmlButtonItems.onLoad = function(bSuccess:Boolean):Void 
{
	if (bSuccess) 
		mcMenuVidAveraging.buttonItems = LoadXmlButtonItems( this );
	else 
		trace("xml failed to load");
};

resolutionXmlButtonItems.onLoad = function(bSuccess:Boolean):Void 
{
	if (bSuccess) 
		mcMenuResolution.buttonItems = LoadXmlButtonItems(this);
	else 
		trace("Resolution xml failed to load");
};

bandXmlButtonItems.onLoad = function(bSuccess:Boolean):Void 
{
	if (bSuccess) 
		mcMenuBand.buttonItems = LoadXmlButtonItems(this);
	else 
		trace("Band xml failed to load");
};

/*----------------------------------------------------------------
run immediately
----------------------------------------------------------------*/
vidAveragingXmlButtonItems.load("xml/buttonItems.xml");
resolutionXmlButtonItems.load("xml/resolutionButtonItems.xml");
bandXmlButtonItems.load("xml/bandButtonItems.xml");


