﻿// ----------------------------------------------------------------
// variable declarations
// ----------------------------------------------------------------
var MAX_IQ_POINTS = 2000;
var pointArray:Array;
var iqData:Array;
var jsPointData:String;
var pointIndex:Number = 0;
var updateCount = 0;
var notifyCount:Number = 0;

var scalingFactor:Number = 4;
var iOffset:Number = 250;
var qOffset:Number = 140;

var constelationState:Boolean = false;
var InitializationComplete:Boolean = false;

// ----------------------------------------------------------------
// instantiate variables
// ----------------------------------------------------------------

pointArray = new Array();
iqData = new Array();
iqData = [
     [  183,    189   ],     [ -167,    193   ],     [ 164 ,    180   ],
     [ 184 ,    -169  ],     [ -177,    169   ],     [ 181 ,    185   ],
     [ 186 ,    -169  ],     [ -181,    168   ],     [ -198,    -178  ],
     [ 165 ,    -193  ],     [ 173 ,    -162  ],     [ -166,    178   ],
     [ 166 ,    -179   ],    [ -180,    166   ],     [ -178,    149   ],
     [ -196,    -193  ],     [ -157,    175   ],     [  183,    -173   ],
     [ -155,    155   ],     [ -170,    192   ],     [  179,    191    ],
     [  165,    -181   ],    [ -170,    -153  ],     [  176,    189    ],
     [ -154,    178   ],     [ -178,    188   ],     [ 183,    192    ],
     [ 196,    -180   ],     [ 169,    163    ],     [ 198,    185    ],
     [ 170,    -183   ],     [ -174,    -192  ],     [ 168,    172    ],
     [ -168,    181   ],     [ 168,    200    ],     [ -171,    168   ],
     [ 162,    -174   ],     [ 190,    153    ],     [ 163,    -170   ],
     [ -172,    167   ],     [ 162,    -168   ],     [ 187,    -170   ],
     [ 172,    164    ],     [ 191,    186    ],     [ -163,    181   ],
     [ -176,    -205  ],     [ 183,    -181   ],     [ -189,    175   ],
     [ -181,    175   ],     [ 185,    185    ],     [ -165,    194   ],
     [ 182,    156    ],     [ 193,    -179   ],     [ 177,    -180   ],
     [ 157,    -163   ],     [ -166,    170   ],     [ 152,    -175   ],
     [ 173,    185    ],     [ -176,    187   ],     [ -153,    184   ],
     [ 178,    204    ],     [ -167,    176   ],     [ -160,    -185  ]];

// ----------------------------------------------------------------
// functions
// ----------------------------------------------------------------

// newPoint constructor
newPoint = function(iValue:Number, qValue:Number):Void
{ 
   this.iValue = iValue;
   this.qValue = qValue;
}

// newPoint array constructor
BuildPointArray = function(iValue:Number, qValue:Number):Void
{ 
   trace(pointIndex);
   if (pointArray.length < MAX_IQ_POINTS)
      pointArray[pointArray.length] = new newPoint(iValue, qValue);
   else 
   {
	  pointArray[pointIndex].iValue = iValue;
	  pointArray[pointIndex].qValue = qValue;
	  if ( ++pointIndex >= MAX_IQ_POINTS )
         pointIndex = 0;
   }
}

// Updates the graph with new data
UpdateGraphConstelationStatus = function(iqContent:String):Void
{
	++updateCount;
   logger.debug("UpdateGraphConstelationStatus ", updateCount);
   logger.debug("iqContent: ", iqContent);
   var dbContent:Array = iqContent.split("\n");
   if ( dbContent.length )
   {
      pointArray = new Array();
      for (var i = 0; i < dbContent.length -1; i++)
      {
         iValue = parseInt(dbContent[i].split(",")[0]);
         qValue = parseInt(dbContent[i].split(",")[1]);
         BuildPointArray(iValue, qValue);
      }

      for (i = 0; i < pointArray.length -1; i++)
      {
         var aPoint = attachMovie ('mcPixel', 'mcPixel' + i, i);
         var pointColor = new Color('mcPixel' + i);
         aPoint._x = (pointArray[i].iValue / scalingFactor) + iOffset;
         aPoint._y = (pointArray[i].qValue / scalingFactor) + qOffset;
         pointColor.setRGB(changePointColor);      
      }

   }
}
ExternalInterface.addCallback("UpdateGraphConstelationStatus", this, UpdateGraphConstelationStatus);

// Used for debugging only
BuildPointContent = function():Void
{
   jsPointData = "";
   for ( var i=0; i < iqData.length; i++)
   {  // Create I&Q data points
      jsPointData = jsPointData + iqData[i][0] + "," + iqData[i][1];
      jsPointData += "\n";
   }
}

ConstelationSamplingEnableDisable = function(aState:Boolean):Void
{
//    logger.debug("ConstelationSamplingEnableDisable Callback", aState);
	if ( aState )
	{  // Sampling is enabled, disable START button and enable STOP button
        logger.debug("START disabled, STOP enabled Callback", aState);
		Start_mc.gotoAndStop("disabled");
		Stop_mc.gotoAndStop("out");
	    Start_mc.enabled = false;
		Stop_mc.enabled = true;
	}
	else
	{  // Sampling is disabled, enable START button and disable STOP button
        logger.debug("START enabled, STOP disabled Callback", aState);
		Start_mc.gotoAndStop("out");
		Stop_mc.gotoAndStop("disabled");
	    Start_mc.enabled = true;
		Stop_mc.enabled = false;
	}
}
ExternalInterface.addCallback("ConstelationSamplingEnableDisable", this, ConstelationSamplingEnableDisable);

// Call into javascript
function OnSwfLoadEventNotifyPage():Void
{  // Invokes the javascript method to notify that swf has finished downloading
   ++notifyCount;
   logger.debug("NotifyPage ", notifyCount);

//   proxy.call( "As2JsOnSwfLoad" );
   ExternalInterface.call( "parent.As2JsOnSwfLoad" );
}

// Callback from javascript
function Js2asSwfLoadNotificationReceived():Void
{  // Invokes the javascript method to notify that swf has finished downloading
   clearInterval(intervalSwfLoadNotification);
   // Now safe to make call into javascript
   InitializationComplete = true;
   logger.debug("Js2asSwfLoadNotificationReceived ", InitializationComplete);
}
ExternalInterface.addCallback("Js2asSwfLoadNotificationReceived", this, Js2asSwfLoadNotificationReceived);

/*----------------------------------------------------------------
event handlers
----------------------------------------------------------------*/
Start_mc.onRollOver = Stop_mc.onRollOver = function():Void
{
    logger.info("Rolled over a button");
	this.gotoAndStop("over");
}

Start_mc.onRollOut = Stop_mc.onRollOut = function():Void
{
    logger.info("Rolled out a button");
    this.gotoAndStop("out");
}

Start_mc.onRelease = function():Void
{
	constelationState = true;
    logger.debug("Released the START button",constelationState);
    ConstelationSamplingEnableDisable( constelationState );
    //Calls JavaScript SetRxIQSamplingState function
    if (InitializationComplete)
    	ExternalInterface.call("parent.client_SetRxIQSamplingState", constelationState );
}

Stop_mc.onRelease = function():Void
{
	constelationState = false;
    logger.debug("Released the STOP button",constelationState);
    ConstelationSamplingEnableDisable( constelationState );
    //Calls JavaScript SetRxIQSamplingState function
    if (InitializationComplete)
       ExternalInterface.call("parent.client_SetRxIQSamplingState", constelationState );
}

/*----------------------------------------------------------------
run immediately
----------------------------------------------------------------*/
intervalSwfLoadNotification = setInterval(this, "OnSwfLoadEventNotifyPage", 500);

//BuildPointContent();                         // Uncomment for debugging
//UpdateGraphConstelationStatus(jsPointData);

//ConstelationSamplingEnableDisable(constelationState);


