﻿// ----------------------------------------------------------------
// variable declarations
// ----------------------------------------------------------------
var notifyCount:Number = 0;
var intervalSwfLoadNotification:Number;

var spectrumState:Boolean = false;
var InitializationComplete:Boolean = false;

var NO_FLASH_DEBUG:Number = 0;
var XDATA_FLASH_DEBUG:Number = 1;
var LOADVARS_FLASH_DEBUG:Number = 2;
var JS_LOADVARS_FLASH_DEBUG:Number = 3;
var SpectrumFlashDebug:Number = NO_FLASH_DEBUG;

var DATA_SEGMENT1:Number = 1;
var DATA_SEGMENT2:Number = 2;
var DATA_SEGMENT3:Number = 3;
var DATA_SEGMENT4:Number = 4;
var maxDataSegments:Number = 16;
var dataSegment:Number = DATA_SEGMENT1;
var dataSegmentInterval:Number;
var dataSegmentsLoaded:Number = 0;
var DATA_SEGMENT_INTERVAL_MSECS:Number = 1000;

// ----------------------------------------------------------------
// instantiate variables
// ----------------------------------------------------------------

loadDataSegment1 = new LoadVars(); 
loadDataSegment2 = new LoadVars(); 
loadDataSegment3 = new LoadVars(); 
loadDataSegment4 = new LoadVars(); 


// ----------------------------------------------------------------
// functions
// ----------------------------------------------------------------

InitializeFlash = function():Void
{
	switch (SpectrumFlashDebug)
	{
        default:
		case  NO_FLASH_DEBUG : // Setup Java script & flash interraction
           intervalSwfLoadNotification = setInterval(this, "OnSwfLoadEventNotifyPage", 500);  
		   break;

	    case  XDATA_FLASH_DEBUG :    // Use xData array
           InitializeTimeDomain();	
           if (++dataSegmentsLoaded > maxDataSegments)
         	  dataSegmentsLoaded = maxDataSegments;
//           logger.debug("InitializeTimeDomain: ", dataSegmentsLoaded);
//           SmoothByHammingWindow();  // Use either Hamming or Blackman
           //SmoothByBlackmanWindow();
           FastFourierTransform();
           FindMaximumAmplitude();
           ZoomEnableDisable();
           if (++dataSegment > maxDataSegments)
	          dataSegment = DATA_SEGMENT1;
//           logger.debug("InitializeTimeDomain dataSegment: ", dataSegmentsLoaded);
		   break;

		case  LOADVARS_FLASH_DEBUG : 
		   // Use loadVars to load the raw data from files dataset-512-x.txt, x goes from 1 to 4
           clearInterval(dataSegmentInterval);
           dataSegmentInterval = setInterval(this, "LoadExternalData", DATA_SEGMENT_INTERVAL_MSECS); 
           break; 

		case  JS_LOADVARS_FLASH_DEBUG : 
		   // Setup Java script & flash interraction
           intervalSwfLoadNotification = setInterval(this, "OnSwfLoadEventNotifyPage", 500);  
           break; 
    }
}

LoadExternalData = function():Void
{
   var aSegment:Number = (dataSegment % 4) + 1;
//   logger.debug("Load External Data Segment ", dataSegment);
//   logger.debug("aSegment ", aSegment);
   switch (aSegment) 
   {
	  default:
      case DATA_SEGMENT1 :  loadDataSegment1.load("dataset-512-" + aSegment + ".txt");
					        break;
      case DATA_SEGMENT2 :  loadDataSegment2.load("dataset-512-" + aSegment + ".txt");
							break;
      case DATA_SEGMENT3 :  loadDataSegment3.load("dataset-512-" + aSegment + ".txt");
							break;
      case DATA_SEGMENT4 :  loadDataSegment4.load("dataset-512-" + aSegment + ".txt");
							break;
   }
}


// Updates the graph with new data
UpdateGraphSpectrumStatus = function(iqContent:String):Void
{
   if ( SpectrumFlashDebug == NO_FLASH_DEBUG )
   {
      logger.debug("UpdateGraphSpectrumStatus Segment #: ", dataSegment);
//      logger.debug("iqContent: ", iqContent);
      var dbContent:Array = iqContent.split("\n");
      if ( dbContent.length )
      {
         if (++dataSegmentsLoaded > maxDataSegments)
     	    dataSegmentsLoaded = maxDataSegments;
//         logger.debug("UpdateGraphSpectrumStatus: ", dataSegmentsLoaded);
         for (var i = 0; i < dbContent.length -1; i++)
         {
            imag[i] = parseInt(dbContent[i].split(",")[0]);
            real[i] = parseInt(dbContent[i].split(",")[1]);
         }

//         SmoothByHammingWindow();  // Use either Hamming or Blackman
//	    SmoothByBlackmanWindow();
         FastFourierTransform();
         FindMaximumAmplitude();
         ZoomEnableDisable(zoomFactor);

         if (++dataSegment > maxDataSegments)
            dataSegment = DATA_SEGMENT1;
//         logger.debug("UpdateGraphSpectrumStatus dataSegment: ", dataSegmentsLoaded);
	  
      }
   }
}
ExternalInterface.addCallback("UpdateGraphSpectrumStatus", this, UpdateGraphSpectrumStatus);

SpectrumSamplingEnableDisable = function(aState:Boolean):Void
{
//    logger.debug("SpectrumSamplingEnableDisable Callback", aState);
	if ( aState )
	{  // Sampling is enabled, disable START button and enable STOP button
        logger.debug("START disabled, STOP enabled Callback", aState);
		Start_mc.gotoAndStop("disabled");
		Stop_mc.gotoAndStop("out");
	    Start_mc.enabled = false;
		Stop_mc.enabled = true;
     	if ( SpectrumFlashDebug == JS_LOADVARS_FLASH_DEBUG )
        {   // Use loadVars to load the raw data from files dataset-512-x.txt, x goes from 1 to 4
           clearInterval(dataSegmentInterval);
           dataSegmentInterval = setInterval(this, "LoadExternalData", DATA_SEGMENT_INTERVAL_MSECS); 
        }
	}
	else
	{  // Sampling is disabled, enable START button and disable STOP button
        logger.debug("START enabled, STOP disabled Callback", aState);
		Start_mc.gotoAndStop("out");
		Stop_mc.gotoAndStop("disabled");
	    Start_mc.enabled = true;
		Stop_mc.enabled = false;
     	if ( SpectrumFlashDebug == JS_LOADVARS_FLASH_DEBUG || 
			 SpectrumFlashDebug == NO_FLASH_DEBUG)
        {   // Use loadVars to load the raw data from files dataset-512-x.txt, x goes from 1 to 4
           clearInterval(dataSegmentInterval);
		   InitializeMagArray();
           dataSegment = DATA_SEGMENT1;
           dataSegmentsLoaded = 0;
        }
	}
}
ExternalInterface.addCallback("SpectrumSamplingEnableDisable", this, SpectrumSamplingEnableDisable);


// Call into javascript
function OnSwfLoadEventNotifyPage():Void
{  // Invokes the javascript method to notify that swf has finished downloading
   ++notifyCount;
   logger.debug("NotifyPage ", notifyCount);
   ExternalInterface.call( "parent.As2JsOnSwfSpectrumLoad" );
}

// Callback from javascript
function Js2asSwfSpectrumLoadNotificationReceived():Void
{  // Invokes the javascript method to notify that swf has finished downloading
   clearInterval(intervalSwfLoadNotification);
   // Now safe to make call into javascript
   InitializationComplete = true;
   logger.debug("Js2asSwfSpectrumLoadNotificationReceived ", InitializationComplete);
}
ExternalInterface.addCallback("Js2asSwfSpectrumLoadNotificationReceived", this, Js2asSwfSpectrumLoadNotificationReceived);

/*----------------------------------------------------------------
event handlers
----------------------------------------------------------------*/
loadDataSegment1.onLoad = loadDataSegment2.onLoad = 
loadDataSegment3.onLoad = loadDataSegment4.onLoad = function(pSuccess:Boolean) 
{ 
   if (pSuccess)
   {
//      logger.debug("External Data Loaded", dataSegment);
      var aSegment:Number = (dataSegment % 4) + 1;
      if (++dataSegmentsLoaded > maxDataSegments)
	     dataSegmentsLoaded = maxDataSegments;
      switch (aSegment) 
	  {
		 default:
         case DATA_SEGMENT1 :   iqContent = this.dataset512_1; break;
         case DATA_SEGMENT2 :   iqContent = this.dataset512_2; break;
         case DATA_SEGMENT3 :   iqContent = this.dataset512_3; break;
         case DATA_SEGMENT4 :   iqContent = this.dataset512_4; break;
	  }
      var dbContent:Array = iqContent.split("\n");
      if ( dbContent.length )
      {
         for (var i = 0; i < dbContent.length -1; i++)
         {
            imag[i] = parseInt(dbContent[i].split(",")[0]);
            real[i] = parseInt(dbContent[i].split(",")[1]);
         }
      }
//	  SmoothByHammingWindow();  // Use either Hamming or Blackman
//	  SmoothByBlackmanWindow();
      FastFourierTransform();
      FindMaximumAmplitude();
      ZoomEnableDisable(zoomFactor);

	  if (++dataSegment > maxDataSegments)
	     dataSegment = DATA_SEGMENT1;
  }
   else
   {
      logger.debug("External Data Load Error", dataSegment);
   }
}; 

Start_mc.onRollOver = Stop_mc.onRollOver = function():Void
{
    logger.info("Rolled over a button");
	this.gotoAndStop("over");
}

Start_mc.onRollOut = Stop_mc.onRollOut = function():Void
{
    logger.info("Rolled out a button");
	this.gotoAndStop("out");
}

Start_mc.onRelease = function():Void
{
	spectrumState = true;
    logger.debug("Released the START button",spectrumState);
    SpectrumSamplingEnableDisable( spectrumState );
    //Calls JavaScript SetRxSpectrumSamplingState function
    if (InitializationComplete)
    	ExternalInterface.call("parent.client_SetRxSpectrumSamplingState", spectrumState );
}

Stop_mc.onRelease = function():Void
{
	spectrumState = false;
    logger.debug("Released the STOP button",spectrumState);
    SpectrumSamplingEnableDisable( spectrumState );
    //Calls JavaScript SetRxSpectrumSamplingState function
    if (InitializationComplete)
       ExternalInterface.call("parent.client_SetRxSpectrumSamplingState", spectrumState );
}

/*----------------------------------------------------------------
run immediately
----------------------------------------------------------------*/


