// ****************************************************************** 
//       * Functions triggered by events in client user interface
// ******************************************************************

// ************************************************************************************
// Name   : client_SetMonEthResetPacketStats()
// Purpose: Called when the reset ethernet packet statistics is clicked
// Inputs : NONE
// Outputs: NONE
function client_SetMonEthResetPacketStats()
{
   serverMonEthIntf.SetMonEthResetPacketStats();
};

// ************************************************************************************
// Name   : client_SetMonEthStatusUpdate()
// Purpose: Called when the current iFrame loads
// Inputs : NONE
// Outputs: NONE
function client_SetMonEthStatusUpdate()
{
   serverMonEthIntf.SetMonEthSelectContentUpdate();
   serverMonEthIntf.SetMonEthStatusUpdate();
};


// ****************************************************************** 
// * Functions called asynchronously from the server.
// ******************************************************************

function asyncUpdateMonEthTotalPacketsStatus(anEthTotalPackets)
{
   var anElement = Get_Iframe_Element( 'EthTotalPacketsInput' ) ;
   if ( anElement )
      anElement.value = anEthTotalPackets;
}

function asyncUpdateMonEthErrorPacketsStatus(anEthErrorPackets)
{
   var anElement = Get_Iframe_Element( 'EthErrorPacketsInput' ) ;
   if ( anElement )
      anElement.value = anEthErrorPackets;
}

function asyncUpdateMonEthPacketErrorRateStatus(anEthPacketErrorRate)
{
   var anElement = Get_Iframe_Element( 'EthPacketErrorRateInput' ) ;
   if ( anElement )
      anElement.value = anEthPacketErrorRate;
}

function asyncUpdateMonEthJs1PortStatusStatus( anEthJs1PortStatus )
{
   var anElement = Get_Iframe_Element( 'EthJs1PortStatusSelect' ) ;
   if( anElement )
      anElement.value = anEthJs1PortStatus;
}

function asyncUpdateMonEthJs2PortStatusStatus( anEthJs2PortStatus )
{
   var anElement = Get_Iframe_Element( 'EthJs2PortStatusSelect' ) ;
   if( anElement )
      anElement.value = anEthJs2PortStatus;
}

function asyncUpdateMonEthJs3PortStatusStatus( anEthJs3PortStatus )
{
   var anElement = Get_Iframe_Element( 'EthJs3PortStatusSelect' ) ;
   if( anElement )
      anElement.value = anEthJs3PortStatus;
}

function asyncUpdateMonEthJs4PortStatusStatus( anEthJs4PortStatus )
{
   var anElement = Get_Iframe_Element( 'EthJs4PortStatusSelect' ) ;
   if( anElement )
      anElement.value = anEthJs4PortStatus;
}

function asyncUpdateMonEthWanStatusStatus(anEthWanStatus)
{
   var anElement = Get_Iframe_Element( 'EthWanStatusSelect' ) ;
   if( anElement )
      anElement.value = anEthWanStatus;
}

// ****************************************************************** 
// * Functions to update the select content.
// ******************************************************************

function asyncUpdateMonEthJs1PortStatusSelectContent( aSelectContent )
{
   Update_Iframe_Element_Select_Content( 'EthJs1PortStatusSelect', aSelectContent );
}

function asyncUpdateMonEthJs2PortStatusSelectContent( aSelectContent )
{
   Update_Iframe_Element_Select_Content( 'EthJs2PortStatusSelect', aSelectContent );
}

function asyncUpdateMonEthJs3PortStatusSelectContent( aSelectContent )
{
   Update_Iframe_Element_Select_Content( 'EthJs3PortStatusSelect', aSelectContent );
}

function asyncUpdateMonEthJs4PortStatusSelectContent( aSelectContent )
{
   Update_Iframe_Element_Select_Content( 'EthJs4PortStatusSelect', aSelectContent );
}

function asyncUpdateMonEthWanStatusSelectContent( aSelectContent )
{
   Update_Iframe_Element_Select_Content( 'EthWanStatusSelect', aSelectContent );
}

