// ****************************************************************** 
//       * Functions triggered by events in client user interface
// ******************************************************************

// ************************************************************************************
// Name   : client_SetPwdEditUser()
// Purpose: Called when user selects a user to edit
//          This function extracts the combo box value and sends the value to the server.
// Inputs : NONE
// Outputs: NONE
function client_SetPwdEditUser()
{
   var anElement = document.getElementById( 'editUserSelect' );
   if ( anElement )	        // Set EditUser
   {   
      serverSetPwdIntf.SetPwdEditUser(anElement.selectedIndex);
      client_SetPwdStatusUpdate();
   }
};

// ************************************************************************************
// Name   : client_SetPwdSiteStatusUpdate()
// Purpose: Called when the current page loads
// Inputs : NONE
// Outputs: NONE
function client_SetPwdSiteStatusUpdate()
{
   Initialize_SetPwdSite();
   client_SetPwdStatusUpdate();
};

// ************************************************************************************
// Name   : client_SetPwdStatusUpdate()
// Purpose: Called when the current page loads
// Inputs : NONE
// Outputs: NONE
function client_SetPwdStatusUpdate()
{
//   serverSetPwdIntf.SetPwdSelectContentUpdate();
   serverSetPwdIntf.SetPwdStatusUpdate();
};

// ****************************************************************** 
// * Functions called asynchronously from the server.
// ******************************************************************

function updateSetPwdEditUserStatus(aUserSelect)
{
   var anElement = document.getElementById( 'editUserSelect' );
   if ( anElement )	        // Set EditUser
      anElement.value = aUserSelect;
}

function updateSetPwdUserAccessGroupStatus(aUserAccessGroup)
{
   var anElement = document.getElementById( 'userAccessGroupSelect' );
   if ( anElement )	        // Set user access group
      anElement.value = aUserAccessGroup;
}

function updateSetPwdUserNameStatus(aUserName)
{
   var anElement = document.getElementById( 'userNameInput' );
   if ( anElement )	        // Set user name
      anElement.value = aUserName;
}

// ********************************************************************
function asyncUpdateSetPwdEditUserStatus(aUserSelect)
{
   updateSetPwdEditUserStatus(aUserSelect);
}

function asyncUpdateSetPwdUser1NameStatus(aUserName)
{
   var anElement = document.getElementById( 'editUserSelect' );
   if ( anElement )	    
   {
      if (anElement.selectedIndex == 0)
      {
         updateSetPwdUserNameStatus(aUserName);
      }
   }
}

function asyncUpdateSetPwdUser1GroupStatus(aUserAccessGroup)
{
   var anElement = document.getElementById( 'editUserSelect' );
   if ( anElement )	    
   {
      if (anElement.selectedIndex == 0)
      {
         updateSetPwdUserAccessGroupStatus(aUserAccessGroup);
      }
   }
}

function asyncUpdateSetPwdUser2NameStatus(aUserName)
{
   var anElement = document.getElementById( 'editUserSelect' );
   if ( anElement )	    
   {
      if (anElement.selectedIndex == 1)
      {
         updateSetPwdUserNameStatus(aUserName);
      }
   }
}

function asyncUpdateSetPwdUser2GroupStatus(aUserAccessGroup)
{
   var anElement = document.getElementById( 'editUserSelect' );
   if ( anElement )	    
   {
      if (anElement.selectedIndex == 1)
      {
         updateSetPwdUserAccessGroupStatus(aUserAccessGroup);
      }
   }
}

function asyncUpdateSetPwdUser3NameStatus(aUserName)
{
   var anElement = document.getElementById( 'editUserSelect' );
   if ( anElement )	    
   {
      if (anElement.selectedIndex == 2)
      {
         updateSetPwdUserNameStatus(aUserName);
      }
   }
}

function asyncUpdateSetPwdUser3GroupStatus(aUserAccessGroup)
{
   var anElement = document.getElementById( 'editUserSelect' );
   if ( anElement )	    
   {
      if (anElement.selectedIndex == 2)
      {
         updateSetPwdUserAccessGroupStatus(aUserAccessGroup);
      }
   }
}

// ****************************************************************** 
// * Functions to update the select content.
// ******************************************************************

function asyncUpdateSetPwdUserGroupSelectContent(aSelectContent)
{
   var anElement = document.getElementById( 'userAccessGroupSelect' );
   Update_Element_Select_Content( anElement, aSelectContent );
}


