//  These are references to instances of the auto-generated interface 
//  ex: a reference to the SC2SIntf class in the SC2SIntf.js JavaScript file.
var serverXmitIfIntf; 
var serverXmitDataIntf; 
var serverXmitAupcIntf; 
var serverXmitRsIntf; 
var serverXmitBucIntf; 

var serverRcvGeneralIntf; 
var serverRcvIfIntf; 
var serverRcvDataIntf; 
var serverRcvRsIntf; 
var serverRcvLnbIntf; 
var serverRcvCncIntf; 

var serverIntfTxSetupIntf; 
var serverIntfRxSetupIntf; 
var serverIntfGeneralIntf; 

var serverMonVoltIntf;          
var serverMonEthIntf; 
var serverMonEventBufferIntf; 
var serverMonCncIntf;          

var serverAlarmTxIntf; 
var serverAlarmRxIntf; 
var serverAlarmComIntf; 
var serverAlarmBkIntf; 

var serverSysTermIntf; 
var serverSysConfIntf; 
var serverSysFeatrIntf; 

var serverTestCarIntf; 
var serverTestPatIntf; 

var serverSetIpIntf; 

var serverSetPwdIntf; 
var serverSetPreferencesIntf; 
var serverSetAppIntf; 

var serverGraphConstelationIntf;
var serverGraphSpectrumIntf;

// EventHandler 
var eh;

var evIsConnected = false; 

var isIE;
var isNav;
var isOpera;
var isWin;
var isMacOS;
var isUnix;

var isIE5Min;
var isNN6Min;

var stdBrowser;
var screenAvailWidth;
var screenAvailHeight;

// Flash objects
var iqFlash;
var spectrumFlash;

// ************************************************************************************
// Name   : isStandardsCompliantBrowser()
// Purpose: Checks if the browser is compliant with the standards. Browsers such as
//          Internet Expoler 5.x or Netscape 6 or later are compliant.
// Inputs : NONE
// Outputs: NONE
function isStandardsCompliantBrowser()
{
   if (document.getElementById)
      return (true);
   else
      return (false);
}

// ************************************************************************************
// Name   : getInternetExplorerVersionNumber()
// Purpose: Check what the minimum version of Internet Explorer is
// Inputs : NONE
// Outputs: NONE
function getInternetExplorerVersionNumber()
{
   var userAgent = navigator.userAgent;
   var offsetMSIE = userAgent.indexOf("MSIE ");
   if (offsetMSIE == -1)
      return (0);
   else
      return (parseFloat(userAgent.substring(offsetMSIE + 5, userAgent.indexOf(";", offsetMSIE))));
}

// ************************************************************************************
// Name   : getNetscapeNavigatorVersionNumber()
// Purpose: Check what the minimum version of Netscape Navigator is
// Inputs : NONE
// Outputs: NONE
function getNetscapeNavigatorVersionNumber()
{
   if (navigator.appName == "Netscape")
   {
      var appVer = parseFloat(navigator.appVersion);
      if (appVer < 5)
         return (appVer);
      else
      {
         if (typeof navigator.vendorSub != "undefined")
            return (parseFloat(navigator.vendorSub));
      }
   }
}

// ************************************************************************************
// Name   : Initialize_Browser_Feature_Detection()
// Purpose: Intialize the browser specific information
// Inputs : 
// Outputs: NONE
function Initialize_Browser_Feature_Detection()
{
   // Updates if browser is standards compliant
   stdBrowser = isStandardsCompliantBrowser();

   // Detect the browser brand
   isIE = (navigator.appName == "Microsoft Internet Explorer");
   isNav = (navigator.appName == "Netscape");
   isOpera = (navigator.userAgent.indexOf("Opera") != -1);

   // Detect the client operating system
   isWin = (navigator.userAgent.indexOf("Win") != -1);
   isMacOS = (navigator.userAgent.indexOf("Mac") != -1);
   isUnix = (navigator.userAgent.indexOf("X11") != -1);

   // Detect an early browser version
   isIE5Min = getInternetExplorerVersionNumber() >= 5;
   isNN6Min = getNetscapeNavigatorVersionNumber() >= 6;
}

// ************************************************************************************
// Name   : Initialize_Browser()
// Purpose: 
// Inputs : 
// Outputs: NONE
function Initialize_Browser() 
{
   var width;
   var height;

   // Intialize the browser specific information
   Initialize_Browser_Feature_Detection();
   screenAvailWidth = screen.availWidth;
   screenAvailHeight = screen.availHeight;

   if (screenAvailWidth <= 875)
      width = screenAvailWidth;
   else
      width = 875;

   if (screenAvailHeight <= 750)
      height = screenAvailHeight;
   else
      height = 750;

   // Resize main window
   window.resizeTo( width, height );
   window.focus();

};

// *************************************************************************************
// Purpose: Create one instance of the Persistent bi-directional
//          asynchronous communication stack. The argument to the
//          constructor is the path to where we have installed the
//          "WebInterface" server side interface.
// Inputs : NONE
// Outputs: NONE
function startMonitorEH() 
{
   eh = new EventHandler("/WebInterface.interface");

   // Create instances of our client to server interfaces and bind the interfaces to the EventHandler.
   serverXmitIfIntf = new C2SXmtIf(eh);
   serverXmitDataIntf = new C2SXmtDt(eh);
   serverXmitAupcIntf = new C2SXmtAp(eh);
   serverXmitRsIntf = new C2SXmtRs(eh);
   serverXmitBucIntf = new C2SXmtBu(eh);

   serverRcvGeneralIntf = new C2SRcvIf(eh);
   serverRcvIfIntf = new C2SRcvIf(eh);
   serverRcvDataIntf = new C2SRcvDt(eh);
   serverRcvRsIntf = new C2SRcvRs(eh);
   serverRcvLnbIntf = new C2SRcvLn(eh);
   serverRcvCncIntf = new C2SRcvCc(eh);

   serverIntfTxSetupIntf = new C2SIntTx(eh);
   serverIntfRxSetupIntf = new C2SIntRx(eh);
   serverIntfGeneralIntf = new C2SIntGn(eh);

   serverMonVoltIntf = new C2SMonVt(eh);
   serverMonEthIntf = new C2SMonEt(eh);
   serverMonEventBufferIntf = new C2SMonEb(eh);
   serverMonCncIntf = new C2SMonCc(eh);

   serverAlarmTxIntf = new C2SAlmTx(eh);
   serverAlarmRxIntf = new C2SAlmRx(eh);
   serverAlarmComIntf = new C2SAlmCm(eh);
   serverAlarmBkIntf = new C2SAlmBk(eh);

   serverSysTermIntf = new C2SSysTe(eh);
   serverSysConfIntf = new C2SSysCg(eh);
   serverSysFeatrIntf = new C2SSysFe(eh);

   serverTestCarIntf = new C2STestC(eh);
   serverTestPatIntf = new C2STestP(eh);

   serverGraphConstelationIntf = new C2SGrphC(eh);
   serverGraphSpectrumIntf = new C2SGrphS(eh);

}

function startSetIpEH() 
{
   eh = new EventHandler("/WebInterface.interface");

   // Create instances of our client to server interfaces and bind the interfaces to the EventHandler.
   serverSetIpIntf = new C2SSetIp(eh);
}

function startSetPwdEH() 
{
   eh = new EventHandler("/WebInterface.interface");

   // Create instances of our client to server interfaces and bind the interfaces to the EventHandler.
   serverSetPwdIntf = new C2SSetPw(eh);
}

function startSetPreferencesEH() 
{
   eh = new EventHandler("/WebInterface.interface");

   // Create instances of our client to server interfaces and bind the interfaces to the EventHandler.
   serverSetPreferencesIntf = new C2SSetPr(eh);
}

function startSetAppEH() 
{
   eh = new EventHandler("/WebInterface.interface");

   // Create instances of our client to server interfaces and bind the interfaces to the EventHandler.
   serverSetAppIntf = new C2SSetAp(eh);
}

// ************************************************************************************
function Initialize_Site() 
{
   Initialize_Browser();
   // Create one instance of the Persistent bi-directional asynchronous communication stack. 
   startMonitorEH();
};

// ************************************************************************************
function Initialize_SetIpSite() 
{
   Initialize_Browser();
   // Create one instance of the Persistent bi-directional asynchronous communication stack. 
   startSetIpEH();
};

// ************************************************************************************
function Initialize_SetPwdSite() 
{
   Initialize_Browser();
   // Create one instance of the Persistent bi-directional asynchronous communication stack. 
   startSetPwdEH();
};

// ************************************************************************************
function Initialize_SetPreferencesSite() 
{
   Initialize_Browser();
   // Create one instance of the Persistent bi-directional asynchronous communication stack. 
   startSetPreferencesEH();
};

// ************************************************************************************
function Initialize_SetAppSite() 
{
   Initialize_Browser();
   // Create one instance of the Persistent bi-directional asynchronous communication stack. 
   startSetAppEH();
};

// ************************************************************************************
// Name   : linkDown()
// Purpose: TEMPOARARY SOLUTION. The LinkHandler (eh) calls this if the
//          link goes down. Works with IE only
// Inputs : 
// Outputs: NONE
function linkDown()
{
   evIsConnected = false;

   // A BUG in IE prevents us from directly calling
   // resetEventHandler. This function is run in the context of
   // the EH iframe, which causes the browser to crash if a new
   // iframe connection is setup from within the iframe itself.
   setTimeout("resetEventHandler();", 100);

   setTimeout("checkLinkHandlerCon()", 3000);
}

// ************************************************************************************
// Name   :	checkLinkHandlerCon()
// Purpose: 
// Inputs : 
// Outputs: NONE
function checkLinkHandlerCon()
{
   if(evIsConnected)
      return;
   alert("Unable to establish a persistent server connection.\n\nLogout then Re-Start a new Session.");
   setTimeout("checkLinkHandlerCon()", 5000);
}

// ************************************************************************************
// Name   : resetEventHandler()
// Purpose: TEMPOARARY SOLUTION. Make the internal EH object reconnect the
//          persistent connection
// Inputs : 
// Outputs: NONE
function resetEventHandler()
{
   eh.cef = 0;
   var src = eh.ef[0].iFr.src;
   eh.ef[0].iFr.src = src;
}

// ************************************************************************************
// Name   : IsBandwidthChangeConfirmed()
// Purpose: Checks whether the bandwidth change is confirmed
// Inputs : aText
// Outputs: false = Not confirmed, true = Confirmed
function IsBandwidthChangeConfirmed(aText)
{
   var confirmed = false;
   if (typeof top.userIsGuest != "undefined")
   {
      if ( top.userIsGuest )
      {
         alert("Guest User Not Authorized to Make Changes ");
         setTimeout("RefreshIframe();", 250);
      }
      else
      {
         if (confirm( aText + " (Bandwidth) Change.\n\nDo You Want to Proceed?" ))
            confirmed = true;
         else
            setTimeout("RefreshIframe();", 250);
      }
   }
   return(confirmed);
}

// ************************************************************************************
// Name   : IsChangeConfirmed()
// Purpose: Checks whether the user wants to confirm all changes
// Inputs : aText
// Outputs: false = Not confirmed, true = Confirmed
function IsChangeConfirmed(aText)
{
   var confirmed = false;
   if (typeof top.userIsGuest != "undefined")
   {
      if ( top.userIsGuest )
      {
         alert("Guest User Not Authorized to Make Changes");
         setTimeout("RefreshIframe();", 250);
      }
      else
      {
         if ( userConfirmation )
         {
            if (confirm( aText + " Change.\n\nDo You Want to Proceed?" ))
               confirmed = true;
            else
               setTimeout("RefreshIframe();", 250);
         }
         else
            confirmed = true;
      }
   }
   return(confirmed);
}

// ************************************************************************************
// Name   : UpdateElementWriteStatus()
// Purpose: Disables/enables element based on authenticated user
// Inputs : anElement
// Outputs: NONE
function UpdateElementWriteStatus(anElement)
{
   if ((typeof top.userIsGuest != "undefined") && (typeof anElement != "undefined"))
   {
      if ( top.userIsGuest )
         anElement.disabled = true;
      else
         anElement.disabled = false;
   }
}
