// ****************************************************************** 
//       * Functions triggered by events in client user interface
// ******************************************************************

// ************************************************************************************
// Name   : client_SetTxDataRate()
// Purpose: Called when user selects a transmit data rate from the TxDataRate edit box.
//          This function extracts the edit box value and sends the value to the server.
// Inputs : anEvent
// Outputs: NONE
//function client_SetTxDataRate(aForm, anElementName, anEvent)
function client_SetTxDataRate(anEvent)
{
   anEvent = (anEvent) ? anEvent : event;
   var charCode = (anEvent.charCode) ? anEvent.charCode : 
                  ((anEvent.which) ? anEvent.which : anEvent.keyCode);
   if (charCode == 13 || charCode == 3)
   {
      var anElement = Get_Iframe_Element( 'TxDataRateInput' ) ;
      if ( anElement )
      {
         if (IsNumber(anElement))
         {
            if (IsBandwidthChangeConfirmed("Tx Data Rate"))
            {
               serverXmitDataIntf.SetTxDataRate(parseInt(anElement.value, 10));
               Focus_Iframe();
            }
         }
      }                           
   }
};

// ************************************************************************************
// Name   : client_SetTxEscOverhead()
// Purpose: Called when user selects a transmit ESC overhead from the TxEscOverhead edit box.
//          This function extracts the edit box value and sends the value to the server.
// Inputs : NONE
// Outputs: NONE
function client_SetTxEscOverhead()
{
   var anElement = Get_Iframe_Element( 'TxEscOverheadSelect' ) ;
   if ( anElement )
   {
      if (IsChangeConfirmed("Tx ESC Overhead"))
      {
         serverXmitDataIntf.SetTxEscOverhead(parseInt(anElement.value, 10));
         Focus_Iframe();
      }
   }
};

// ************************************************************************************
// Purpose: Called when user selects a transmit Inner Fec from the TxInnerFec combo box.
//          This function extracts the combo box value and sends the value to the server.
// Inputs : NONE
// Outputs: NONE
function client_SetTxInnerFec()
{
   var anElement = Get_Iframe_Element( 'TxInnerFecSelect' ) ;
   if( anElement )
   {
      if( IsBandwidthChangeConfirmed( "Tx Inner FEC" ) )
      {
         serverXmitDataIntf.SetTxInnerFec( parseInt( anElement.value, 10 ) );
         Focus_Iframe();
      }
   }
   setTimeout(" RefreshIframe();", 250 );
};

function client_SetTxIfecInterleaver()
{
   var anElement = Get_Iframe_Element( 'TxIfecInterleaverSelect' ) ;
   if ( anElement )
   {
      if (IsChangeConfirmed("Tx Ifec Interleaver"))
      {
         serverXmitDataIntf.SetTxIfecInterleaver(parseInt(anElement.value, 10));
         Focus_Iframe();
      }
   }
};

// ************************************************************************************
function client_SetTxSatelliteFramingCat()
{
   var anElement = Get_Iframe_Element( 'TxSatelliteFramingCatSelect' ) ;
   if( anElement )
   {
      if( IsBandwidthChangeConfirmed( "Tx Satellite Framing" ) )
      {
         serverXmitDataIntf.SetTxSatelliteFramingCat( parseInt( anElement.value), 10 );
         Focus_Iframe();
      }
   }
   setTimeout( "RefreshIframe();", 250 );
};

// ************************************************************************************
// Name   : client_SetTxTerrestrialFraming()
// Purpose: Called when user selects a transmit terrestrial framing.
//          This function extracts the combo box value and sends the value to the server.
// Inputs : NONE
// Outputs: NONE
function client_SetTxTerrestrialFraming()
{
   var anElement = Get_Iframe_Element( 'TxTerrestrialFramingSelect' ) ;
   if ( anElement )
   {
      if (IsChangeConfirmed("Tx Terrestrial Framing"))
      {
         serverXmitDataIntf.SetTxTerrestrialFraming(parseInt(anElement.value, 10));
         Focus_Iframe();
      }
   }
};

// ************************************************************************************
// Name   : client_SetTxScramblerControl()
// Purpose: Called when user selects a transmit scrambler control from the TxScramblerControl combo box.
//          This function extracts the combo box value and sends the value to the server.
// Inputs : NONE
// Outputs: NONE
function client_SetTxScramblerControl()
{
   var anElement = Get_Iframe_Element( 'TxScramblerControlSelect' ) ;
   if ( anElement )
   {
      if (IsChangeConfirmed("Tx Scrambler Control"))
      {
         serverXmitDataIntf.SetTxScramblerControl(parseInt(anElement.value, 10));
         Focus_Iframe();
      }
   }
};

// ************************************************************************************
// Name   : client_SetTxScramblerSelection()
// Purpose: Called when user selects a transmit scrambler selection from the TxScramblerSelection combo box.
//          This function extracts the combo box value and sends the value to the server.
// Inputs : NONE
// Outputs: NONE
function client_SetTxScramblerSelection()
{
   var anElement = Get_Iframe_Element( 'TxScramblerSelectionSelect' ) ;
   if ( anElement )
   {
      if (IsChangeConfirmed("Tx Scrambler Selection"))
      {
         serverXmitDataIntf.SetTxScramblerSelection(parseInt(anElement.value, 10));
         Focus_Iframe();
      }
   }
};

// ************************************************************************************
// Name   : client_SetTxDifferentialCoding()
// Purpose: Called when user selects a transmit differetial coding.
//          This function extracts the combo box value and sends the value to the server.
// Inputs : NONE
// Outputs: NONE
function client_SetTxDifferentialCoding()
{
   var anElement = Get_Iframe_Element( 'TxDifferentialCodingSelect' ) ;
   if ( anElement )
   {
      if (IsChangeConfirmed("Tx Differetial Coding"))
      {
         serverXmitDataIntf.SetTxDifferentialCoding(parseInt(anElement.value, 10));
         Focus_Iframe();
      }
   }
};

// ************************************************************************************
// Name   : client_SetTxDataPolarity()
// Purpose: Called when user selects a transmit data polarity.
//          This function extracts the combo box value and sends the value to the server.
// Inputs : NONE
// Outputs: NONE
function client_SetTxDataPolarity()
{
   var anElement = Get_Iframe_Element( 'TxDataPolaritySelect' ) ;
   if ( anElement )
   {
      if (IsChangeConfirmed("Tx Data Polarity"))
      {
         serverXmitDataIntf.SetTxDataPolarity(parseInt(anElement.value, 10));
         Focus_Iframe();
      }
   }
};

// ************************************************************************************
function client_SetTxSymbolPair()
{
   var anElement = Get_Iframe_Element( 'TxSymbolPairSelect' ) ;
   if( anElement )
   {
      if( IsChangeConfirmed( "Tx Symbol Pair" ) )
      {
         serverXmitDataIntf.SetTxSymbolPair(parseInt( anElement.value ), 10 );
         Focus_Iframe();
      }
   }
};

// ************************************************************************************
function client_SetTxSccControlRatio()
{
   var anElement = Get_Iframe_Element( 'TxSccControlRatioSelect' ) ;
   if ( anElement )
   {
      if (IsChangeConfirmed("Tx SCC Control Ratio"))
      {
         serverXmitDataIntf.SetTxSccControlRatio(parseInt(anElement.value, 10));
         Focus_Iframe();
      }
   }
};

// ************************************************************************************
// Name   : client_SetTxSccInbandRate()
// Purpose: Called when user selects a transmit data rate from the TxSccInbandRate edit box.
//          This function extracts the edit box value and sends the value to the server.
// Inputs : anEvent
// Outputs: NONE
function client_SetTxSccInbandRate(anEvent)
{
   anEvent = (anEvent) ? anEvent : event;
   var charCode = (anEvent.charCode) ? anEvent.charCode : 
                  ((anEvent.which) ? anEvent.which : anEvent.keyCode);
   if (charCode == 13 || charCode == 3)
   {
      var anElement = Get_Iframe_Element( 'TxSccInbandRateInput' ) ;
      if ( anElement )
	   {
		   if (IsNumber(anElement))
		   {
            if (IsChangeConfirmed("Tx SCC Inband Rate"))
            {
               serverXmitDataIntf.SetTxSccInbandRate(parseInt(anElement.value, 10));
               Focus_Iframe();
            }
		   }
	   }
   }
};

// ************************************************************************************
// Name   : client_SetTxAsyncInbandRate()
// Purpose: Called when user selects a transmit data rate from the TxAsyncInbandRateInput
//          combo box.
// Inputs : anEvent
// Outputs: NONE
function client_SetTxAsyncInbandRate()
{
   var anElement = Get_Iframe_Element( 'TxAsyncInbandRateSelect' ) ;
   if ( anElement )
   {
      if (IsChangeConfirmed("Tx Async Inband Rate"))
      {
         serverXmitDataIntf.SetTxAsyncInbandRate(parseInt(anElement.value, 10));
         Focus_Iframe();
      }
   }
};

// ************************************************************************************
// Name   : client_SetTxDataStatusUpdate()
// Purpose: Called when the current iFrame loads
// Inputs : NONE
// Outputs: NONE
function client_SetTxDataStatusUpdate()
{
   serverXmitDataIntf.SetTxDataSelectContentUpdate();
   serverXmitDataIntf.SetTxDataStatusUpdate();
};


// ****************************************************************** 
// * Functions called asynchronously from the server.
// ******************************************************************

function asyncUpdateXmitDataRateStatus(aDataRate)
{
   var anElement = Get_Iframe_Element( 'TxDataRateInput' ) ;
   if ( anElement )
      anElement.value = aDataRate;
}

function asyncUpdateXmitSymbolRateStatus(aSymbolRate)
{
   var anElement = Get_Iframe_Element( 'TxSymbolRateInput' ) ;
   if ( anElement )
      anElement.value = aSymbolRate;
}

function asyncUpdateXmitInnerFecStatus( anInnerFec )
{
   var anElement = Get_Iframe_Element( 'TxInnerFecSelect' );
   if( anElement )
      anElement.value = anInnerFec;
};

function asyncUpdateXmitIfecInterleaverStatus(aInterleaver)
{
   var anElement = Get_Iframe_Element( 'TxIfecInterleaverSelect' ) ;
   if ( anElement )
      anElement.value = aInterleaver;
}

function asyncUpdateXmitSatelliteFramingCatStatus( aSatelliteFramingCat )
{
   var anElement = Get_Iframe_Element( 'TxSatelliteFramingCatSelect' ) ;
   if( anElement )
      anElement.value = aSatelliteFramingCat;
}

function asyncUpdateXmitTerrestrialFramingStatus( aTerrestrialFraming )
{
   var anElement = Get_Iframe_Element( 'TxTerrestrialFramingSelect' ) ;
   if( anElement )
      anElement.value = aTerrestrialFraming;
}

function asyncUpdateXmitEscOverheadStatus(anEscOverhead)
{
   var anElement = Get_Iframe_Element( 'TxEscOverheadSelect' ) ;
   if ( anElement )
      anElement.value = anEscOverhead;
}

function asyncUpdateXmitScramblerControlStatus(aScramblerControl)
{
   var anElement = Get_Iframe_Element( 'TxScramblerControlSelect' ) ;
   if ( anElement )
      anElement.value = aScramblerControl;
}

function asyncUpdateXmitScramblerSelectionStatus(aScramblerSelection)
{
   var anElement = Get_Iframe_Element( 'TxScramblerSelectionSelect' ) ;
   if ( anElement )	    // Set transmit scrambler selection
      anElement.value = aScramblerSelection;
}

function asyncUpdateXmitDifferentialCodingStatus(aDifferentialCoding)
{
   var anElement = Get_Iframe_Element( 'TxDifferentialCodingSelect' ) ;
   if ( anElement )	          // Set transmit differential coding
      anElement.value = aDifferentialCoding;
}

function asyncUpdateXmitDataPolarityStatus(aDataPolarity)
{
   var anElement = Get_Iframe_Element( 'TxDataPolaritySelect' ) ;
   if ( anElement )	             // Set transmit data polarity
      anElement.value = aDataPolarity;
}

function asyncUpdateXmitSymbolPairStatus(aSymbolPair)
{
   var anElement = Get_Iframe_Element( 'TxSymbolPairSelect' ) ;
   if ( anElement )	               // Set transmit symbol pair
      anElement.value = aSymbolPair;
}

function asyncUpdateXmitSccControlRatioStatus(aSccControlRatio)
{
   var anElement = Get_Iframe_Element( 'TxSccControlRatioSelect' ) ;
   if ( anElement )	               // Set transmit Scc Control Ratio
      anElement.value = aSccControlRatio;
}

function asyncUpdateXmitSccInbandRateStatus(aSccInbandRate)
{
   var anElement = Get_Iframe_Element( 'TxSccInbandRateInput' ) ;
   if ( anElement )
      anElement.value = aSccInbandRate;
}

function asyncUpdateXmitAsyncInbandRateStatus(anAsyncInbandRate)
{
   var anElement = Get_Iframe_Element( 'TxAsyncInbandRateSelect' ) ;
   if ( anElement )	               // Set transmit async inband rate
      anElement.value = anAsyncInbandRate;
}

// ****************************************************************** 
function asyncUpdateXmitInnerFecSelectContent( aSelectContent )
{
   Update_Iframe_Element_Select_Content( 'TxInnerFecSelect', aSelectContent );
};

function asyncUpdateXmitIfecInterleaverSelectContent(aSelectContent)
{
   Update_Iframe_Element_Select_Content( 'TxIfecInterleaverSelect', aSelectContent );
}

function asyncUpdateXmitSatelliteFramingCatSelectContent( aSelectContent )
{
   Update_Iframe_Element_Select_Content( 'TxSatelliteFramingCatSelect', aSelectContent );
}

function asyncUpdateXmitTerrestrialFramingSelectContent(aSelectContent)
{
   Update_Iframe_Element_Select_Content( 'TxTerrestrialFramingSelect', aSelectContent );
}

function asyncUpdateXmitEscOverheadSelectContent(aSelectContent)
{
   Update_Iframe_Element_Select_Content( 'TxEscOverheadSelect', aSelectContent );
}

function asyncUpdateXmitScramblerControlSelectContent(aSelectContent)
{
   Update_Iframe_Element_Select_Content( 'TxScramblerControlSelect', aSelectContent );
}

function asyncUpdateXmitScramblerSelectionSelectContent(aSelectContent)
{
   Update_Iframe_Element_Select_Content( 'TxScramblerSelectionSelect', aSelectContent );
}

function asyncUpdateXmitDifferentialCodingSelectContent(aSelectContent)
{
   Update_Iframe_Element_Select_Content( 'TxDifferentialCodingSelect', aSelectContent );
}

function asyncUpdateXmitDataPolaritySelectContent(aSelectContent)
{
   Update_Iframe_Element_Select_Content( 'TxDataPolaritySelect', aSelectContent );
}

function asyncUpdateXmitSymbolPairSelectContent(aSelectContent)
{
   Update_Iframe_Element_Select_Content( 'TxSymbolPairSelect', aSelectContent );
}

function asyncUpdateXmitSccControlRatioSelectContent(aSelectContent)
{
   Update_Iframe_Element_Select_Content( 'TxSccControlRatioSelect', aSelectContent );
}

function asyncUpdateXmitAsyncInbandRateSelectContent(aSelectContent)
{
   Update_Iframe_Element_Select_Content( 'TxAsyncInbandRateSelect', aSelectContent );
}
