// ****************************************************************** 
//       * Functions triggered by events in client user interface
// ******************************************************************

// ************************************************************************************
// Purpose: Called when user selects a transmit AUPC TrackingRate
//          This function extracts the edit box value and sends the value to the server.
// Inputs : NONE
// Outputs: NONE
function client_SetTxAupcTrackingRate()
{
   var anElement = Get_Iframe_Element( 'TxAupcTrackingRateSelect' ) ;
   if ( anElement )
   {
      if (IsChangeConfirmed("Tx EF AUPC Tracking Rate"))
      {
         serverXmitAupcIntf.SetTxAupcTrackingRate(parseInt(anElement.value, 10));
         Focus_Iframe();
      }
   }
};

// ************************************************************************************
// Purpose: Called when user selects a transmit AUPC LocalClAction
//          This function extracts the edit box value and sends the value to the server.
// Inputs : NONE
// Outputs: NONE
function client_SetTxAupcLocalClAction()
{
   var anElement = Get_Iframe_Element( 'TxAupcLocalClActionSelect' ) ;
   if ( anElement )
   {
      if (IsChangeConfirmed("Tx EF AUPC Local Carrier Loss Action"))
      {
         serverXmitAupcIntf.SetTxAupcLocalClAction(parseInt(anElement.value, 10));
         Focus_Iframe();
      }
   }
};

// ************************************************************************************
// Purpose: Called when user selects a transmit AUPC RemoteClAction
//          This function extracts the edit box value and sends the value to the server.
// Inputs : NONE
// Outputs: NONE
function client_SetTxAupcRemoteClAction()
{
   var anElement = Get_Iframe_Element( 'TxAupcRemoteClActionSelect' ) ;
   if ( anElement )
   {
      if (IsChangeConfirmed("Tx EF AUPC Remote Carrier Loss Action"))
      {
         serverXmitAupcIntf.SetTxAupcRemoteClAction(parseInt(anElement.value, 10));
         Focus_Iframe();
      }
   }
};

// ************************************************************************************
// Purpose: Called when user selects a transmit AUPC remote mode.
//          This function extracts the edit box value and sends the value to the server.
// Inputs : NONE
// Outputs: NONE
function client_SetTxAupcRemoteMode()
{
   var anElement = Get_Iframe_Element( 'TxAupcRemoteModeSelect' ) ;
   if ( anElement )
   {
      if (IsChangeConfirmed("Tx EF AUPC Remote Mode"))
      {
         serverXmitAupcIntf.SetTxAupcRemoteMode(parseInt(anElement.value, 10));
         Focus_Iframe();
      }
   }
};

// ************************************************************************************
// Purpose: Called when user selects a transmit AUPC remote Loopback.
//          This function extracts the edit box value and sends the value to the server.
// Inputs : NONE
// Outputs: NONE
function client_SetTxAupcRemoteLoopback()
{
   var anElement = Get_Iframe_Element( 'TxAupcRemoteLoopbackSelect' ) ;
   if ( anElement )
   {
      if (IsChangeConfirmed("Tx EF AUPC Remote Loopback"))
      {
         serverXmitAupcIntf.SetTxAupcRemoteLoopback(parseInt(anElement.value, 10));
         Focus_Iframe();
      }
   }
};

// ************************************************************************************
// Purpose: Called when user selects a transmit AUPC remote 2047Pattern.
//          This function extracts the edit box value and sends the value to the server.
// Inputs : NONE
// Outputs: NONE
function client_SetTxAupcRemote2047Pattern()
{
   var anElement = Get_Iframe_Element( 'TxAupcRemote2047PatternSelect' ) ;
   if ( anElement )
   {
      if (IsChangeConfirmed("Tx EF AUPC Remote 2047 Pattern"))
      {
         serverXmitAupcIntf.SetTxAupcRemote2047Pattern(parseInt(anElement.value, 10));
         Focus_Iframe();
      }
   }
};

// ************************************************************************************
// Purpose: Called when the current iFrame loads
// Inputs : NONE
// Outputs: NONE
function client_SetTxAupcStatusUpdate()
{
   serverXmitAupcIntf.SetTxAupcSelectContentUpdate();
   serverXmitAupcIntf.SetTxAupcStatusUpdate();
};


// ****************************************************************** 
// * Functions called asynchronously from the server.
// ******************************************************************

function asyncUpdateXmitAupcModeStatus(anAupcMode)
{
   var anElement = Get_Iframe_Element( 'TxAupcModeSelect' ) ;
   if ( anElement )
      anElement.value = anAupcMode;
}

function asyncUpdateXmitAupcEbnoStatus(anAupcEbno)
{
   var anElement = Get_Iframe_Element( 'TxAupcEbnoInput' ) ;
   if ( anElement )
      anElement.value = anAupcEbno;
}

function asyncUpdateXmitAupcMinPowerStatus(anAupcMinPower)
{
   var anElement = Get_Iframe_Element( 'TxAupcMinPowerInput' ) ;
   if ( anElement )
      anElement.value = FormatNumber(anAupcMinPower, 1);
}

function asyncUpdateXmitAupcMaxPowerStatus(anAupcMaxPower)
{
   var anElement = Get_Iframe_Element( 'TxAupcMaxPowerInput' ) ;
   if ( anElement )
      anElement.value = FormatNumber(anAupcMaxPower, 1);
}

function asyncUpdateXmitAupcDefPowerStatus(anAupcDefPower)
{
   var anElement = Get_Iframe_Element( 'TxAupcDefPowerInput' ) ;
   if ( anElement )
      anElement.value = FormatNumber(anAupcDefPower, 1);
}

function asyncUpdateXmitAupcTrackingRateStatus(anAupcTrackingRate)
{
   var anElement = Get_Iframe_Element( 'TxAupcTrackingRateSelect' ) ;
   if ( anElement )
      anElement.value = anAupcTrackingRate;
}

function asyncUpdateXmitAupcLocalClActionStatus(anAupcLocalClAction)
{
   var anElement = Get_Iframe_Element( 'TxAupcLocalClActionSelect' ) ;
   if ( anElement )
      anElement.value = anAupcLocalClAction;
}

function asyncUpdateXmitAupcRemoteClActionStatus(anAupcRemoteClAction)
{
   var anElement = Get_Iframe_Element( 'TxAupcRemoteClActionSelect' ) ;
   if ( anElement )
      anElement.value = anAupcRemoteClAction;
}

function asyncUpdateXmitAupcRemoteModeStatus(anAupcRemoteMode)
{
   var anElement = Get_Iframe_Element( 'TxAupcRemoteModeSelect' ) ;
   if ( anElement )
      anElement.value = anAupcRemoteMode;
}

function asyncUpdateXmitAupcRemoteLoopbackStatus(anAupcRemoteLoopback)
{
   var anElement = Get_Iframe_Element( 'TxAupcRemoteLoopbackSelect' ) ;
   if ( anElement )
      anElement.value = anAupcRemoteLoopback;
}

function asyncUpdateXmitAupcRemote2047PatternStatus(anAupcRemote2047Pattern)
{
   var anElement = Get_Iframe_Element( 'TxAupcRemote2047PatternSelect' ) ;
   if ( anElement )
      anElement.value = anAupcRemote2047Pattern;
}

function asyncUpdateXmitAupcRemoteBerStatus(anAupcRemoteBer)
{
   var anElement = Get_Iframe_Element( 'TxAupcRemoteBerInput' ) ;
   if ( anElement )
      anElement.value = anAupcRemoteBer;
}

// ****************************************************************** 
// * Functions to update the select content.
// ******************************************************************

function asyncUpdateXmitAupcModeSelectContent(aSelectContent)
{
   Update_Iframe_Element_Select_Content( 'TxAupcModeSelect', aSelectContent );
}

function asyncUpdateXmitAupcTrackingRateSelectContent(aSelectContent)
{
   Update_Iframe_Element_Select_Content( 'TxAupcTrackingRateSelect', aSelectContent );
}

function asyncUpdateXmitAupcLocalClActionSelectContent(aSelectContent)
{
   Update_Iframe_Element_Select_Content( 'TxAupcLocalClActionSelect', aSelectContent );
}

function asyncUpdateXmitAupcRemoteClActionSelectContent(aSelectContent)
{
   Update_Iframe_Element_Select_Content( 'TxAupcRemoteClActionSelect', aSelectContent );
}

function asyncUpdateXmitAupcRemoteModeSelectContent(aSelectContent)
{
   Update_Iframe_Element_Select_Content( 'TxAupcRemoteModeSelect', aSelectContent );
}

function asyncUpdateXmitAupcRemoteLoopbackSelectContent(aSelectContent)
{
   Update_Iframe_Element_Select_Content( 'TxAupcRemoteLoopbackSelect', aSelectContent );
}

function asyncUpdateXmitAupcRemote2047PatternSelectContent(aSelectContent)
{
   Update_Iframe_Element_Select_Content( 'TxAupcRemote2047PatternSelect', aSelectContent );
}

